<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class ManutencaoVenda {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	public function savePedingSale($CDFILIAL, $CDCAIXA, $CDCLIENTE, $CDCONSUMIDOR, $CDSERVFILI, $CDVENDEDOR, $DTABERTUR, $DTENTRVENDA, $DTVENDA, $IDORIGEMVENDA, $IDSITUVENDA, $IDTIPOVENDA, $IDTPEMISVEND, $NRCUPOMFIS, $NRSEQVENDA, $NRORDEMVND, $NRSERIEIMPVND, $NRSERIEVND, $NRSUBSERIEVND, $CDEMPRESA, $CDLOJA, $CDOPERADOR, $NRORG){		
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':CDCLIENTE' => $CDCLIENTE,
			':CDCONSUMIDOR' => $CDCONSUMIDOR,
			':CDSERVFILI' => $CDSERVFILI,
			':CDVENDEDOR' => $CDVENDEDOR,
			':DTABERTUR' => $DTABERTUR,
			':DTENTRVENDA' => $DTENTRVENDA,
			':DTVENDA' => $DTVENDA,
			':IDORIGEMVENDA' => $IDORIGEMVENDA,
			':IDSITUVENDA' => $IDSITUVENDA,
			':IDTIPOVENDA' => $IDTIPOVENDA,
			':IDTPEMISVEND' => $IDTPEMISVEND,
			':NRCUPOMFIS' => $NRCUPOMFIS,
			':NRSEQVENDA' => $NRSEQVENDA,
			':NRORDEMVND' => $NRORDEMVND,
			':NRSERIEIMPVND' => $NRSERIEIMPVND,
			':NRSERIEVND' => $NRSERIEVND,
			':NRSUBSERIEVND' => $NRSUBSERIEVND, 
			':CDEMPRESA' => $CDEMPRESA,
			':CDLOJA'    => $CDLOJA, 
			':CDOPERADOR' => $CDOPERADOR,
			':NRORG'   => $NRORG,
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_PENDING_SALE, $params);
	}

	public function saveItem($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQUITVEND, $QTPRODVEND, $VRUNITVEND, $VRDESITVEND, $VRPERCVEND, $CDPRODUTO, $VRUNITVENDCL, $VRACRITVEND, $NRORG, $CDOPERINCLUSAO){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRSEQVENDA' => $NRSEQVENDA,
			':NRSEQUITVEND' => $NRSEQUITVEND,
			':QTPRODVEND' => $QTPRODVEND,
			':VRUNITVEND' => $VRUNITVEND,
			':VRDESITVEND' => $VRDESITVEND,
			':VRPERCVEND' => $VRPERCVEND,
			':CDPRODUTO' => $CDPRODUTO,
			':VRUNITVENDCL' => $VRUNITVENDCL,
			':VRACRITVEND' => $VRACRITVEND,
			':NRORG' => $NRORG,
			':CDOPERINCLUSAO' => $CDOPERINCLUSAO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_ITEM, $params);
	}
	
	public function updateItem($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQUITVEND, $QTPRODVEND, $VRUNITVEND, $VRDESITVEND, $VRPERCVEND, $CDPRODUTO, $VRUNITVENDCL, $VRACRITVEND, $NRORG, $CDOPERINCLUSAO, $CDSUBGRPROD, $CDGRUPPROD, $CDFISUBGRVND){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRSEQVENDA' => $NRSEQVENDA,
			':NRSEQUITVEND' => $NRSEQUITVEND,
			':QTPRODVEND' => $QTPRODVEND,
			':VRUNITVEND' => $VRUNITVEND,
			':VRDESITVEND' => $VRDESITVEND,
			':VRPERCVEND' => $VRPERCVEND,
			':CDPRODUTO' => $CDPRODUTO,
			':VRUNITVENDCL' => $VRUNITVENDCL,
			':VRACRITVEND' => $VRACRITVEND,
			':CDSUBGRPROD' => $CDSUBGRPROD, 
			':CDGRUPPROD' => $CDGRUPPROD, 
			':CDFISUBGRVND' => $CDFISUBGRVND,
			':NRORG' => $NRORG,
			':CDOPERINCLUSAO' => $CDOPERINCLUSAO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_ITEM, $params);
	}

	public function saveImpoItem($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQUITVEND, $NRSEQITIMPOS, $CDIMPOSTO, $VRPEALPRODIT, $VRIMPOPRODIT, $CDIMPOSTOEX, $NRORG, $CDOPERINCLUSAO){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRSEQVENDA' => $NRSEQVENDA,
			':NRSEQUITVEND' => $NRSEQUITVEND,
			':NRSEQITIMPOS' => $NRSEQITIMPOS,
			':CDIMPOSTO' => $CDIMPOSTO,
			':VRPEALPRODIT' => $VRPEALPRODIT,
			':VRIMPOPRODIT' => $VRIMPOPRODIT,
			':CDIMPOSTOEX' => $CDIMPOSTOEX,
			':NRORG' => $NRORG,
			':CDOPERINCLUSAO' => $CDOPERINCLUSAO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_ITEM_IMPOSTO, $params);
	}
	
		public function updateImpoItem($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQUITVEND, $NRSEQITIMPOS, $CDIMPOSTO, $VRPEALPRODIT, $VRIMPOPRODIT, $CDIMPOSTOEX, $NRORG, $CDOPERINCLUSAO){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRSEQVENDA' => $NRSEQVENDA,
			':NRSEQUITVEND' => $NRSEQUITVEND,
			':NRSEQITIMPOS' => $NRSEQITIMPOS,
			':CDIMPOSTO' => $CDIMPOSTO,
			':VRPEALPRODIT' => $VRPEALPRODIT,
			':VRIMPOPRODIT' => $VRIMPOPRODIT,
			':CDIMPOSTOEX' => $CDIMPOSTOEX,
			':NRORG' => $NRORG,
			':CDOPERINCLUSAO' => $CDOPERINCLUSAO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_ITEM_IMPOSTO, $params);
	}
	public function saveItemCancelado($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQITVENDC, $QTPRODVENDC, $VRUNITVENDC, $VRDESITVENDC, $VRPERCVENDC, $CDPRODUTO, $VRUNITVENCLC, $VRACRITVENDC, $NRORG, $CDOPERINCLUSAO){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRSEQVENDA' => $NRSEQVENDA,
			':NRSEQITVENDC' => $NRSEQITVENDC,
			':QTPRODVENDC' => $QTPRODVENDC,
			':VRUNITVENDC' => $VRUNITVENDC,
			':VRDESITVENDC' => $VRDESITVENDC,
			':VRPERCVENDC' => $VRPERCVENDC,
			':CDPRODUTO' => $CDPRODUTO,
			':VRUNITVENCLC' => $VRUNITVENCLC,
			':VRACRITVENDC' => $VRACRITVENDC,
			':NRORG' => $NRORG,
			':CDOPERINCLUSAO' => $CDOPERINCLUSAO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_CANCEL_ITEM, $params);
	}
	
	public function updateItemCancelado($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQITVENDC, $QTPRODVENDC, $VRUNITVENDC, $VRDESITVENDC, $VRPERCVENDC, $CDPRODUTO, $VRUNITVENCLC, $VRACRITVENDC, $NRORG, $CDOPERINCLUSAO, $CDSUBGRPROD, $CDGRUPPROD, $CDFISUBGRVNC){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRSEQVENDA' => $NRSEQVENDA,
			':NRSEQITVENDC' => $NRSEQITVENDC,
			':QTPRODVENDC' => $QTPRODVENDC,
			':VRUNITVENDC' => $VRUNITVENDC,
			':VRDESITVENDC' => $VRDESITVENDC,
			':VRPERCVENDC' => $VRPERCVENDC,
			':CDPRODUTO' => $CDPRODUTO,
			':VRUNITVENCLC' => $VRUNITVENCLC,
			':VRACRITVENDC' => $VRACRITVENDC,
			':CDSUBGRPROD'  => $CDSUBGRPROD,
			':CDGRUPPROD'  => $CDGRUPPROD,
			':CDFISUBGRVNC'  => $CDFISUBGRVNC,
			':NRORG' => $NRORG,
			':CDOPERINCLUSAO' => $CDOPERINCLUSAO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_CANCEL_ITEM, $params);
	}
	public function savePayment($CDTIPORECE, $VRMOVIVEND, $CDFILIAL, $CDCAIXA, $DTABERCAIX, $NRSEQUMOVI, $IDTIPOMOVIVE, $NRSEQVENDA, $DTMOVIMCAIXA, $VRMOVIVEOUT, $QTPARCRECEB, $NRORG, $CDOPERINCLUSAO){
		$params = array(
			':CDTIPORECE' => $CDTIPORECE,
			':VRMOVIVEND' => $VRMOVIVEND,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':DTABERCAIX' => $DTABERCAIX,
			':NRSEQUMOVI' => $NRSEQUMOVI,
			':IDTIPOMOVIVE' => $IDTIPOMOVIVE,
			':NRSEQVENDA' => $NRSEQVENDA,
			':DTMOVIMCAIXA' => $DTMOVIMCAIXA,
			':VRMOVIVEOUT' => $VRMOVIVEOUT,
			':QTPARCRECEB' => $QTPARCRECEB,
			':NRORG' => $NRORG,
			':CDOPERINCLUSAO' => $CDOPERINCLUSAO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_PAYMENT, $params);
	}

	public function getSeqItem($NRSEQVENDA, $CDFILIAL, $CDCAIXA){
		$params = array(
			':NRSEQVENDA' => $NRSEQVENDA,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA
		);
		$return = $this->entityManager->getConnection()->fetchAll(Utilities\Query::SEQITEMVENDA, $params);
		$return = $return[0]['NRSEQUITVEND'];
		if(strlen ($return) <= 3){
			if (strlen ($return) <= 2){
				if (strlen ($return) == 1){
					$return = '00'.$return;
					return $return;
				}
				$return = '0'.$return;
				return $return;
			}
			return $return;
		}
		else{
			$return = substr($return, 1);
			if(strlen($return) > 3){
				$return = substr($return, 1);
			}
			return $return;
		}
	}

	public function getSeqItemCan($NRSEQVENDA, $CDFILIAL, $CDCAIXA){
		$params = array(
			':NRSEQVENDA' => $NRSEQVENDA,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA
		);
		$return = $this->entityManager->getConnection()->fetchAll(Utilities\Query::SEQITEMVENDACAN, $params);
		$return = $return[0]['NRSEQITVENDC'];
		if(strlen ($return) <= 3){
			if (strlen ($return) <= 2){
				if (strlen ($return) == 1){
					$return = '00'.$return;
					return $return;
				}
				$return = '0'.$return;
				return $return;
			}
			return $return;
		}
		else{
			$return = substr($return, 1);
			if(strlen($return) > 3){
				$return = substr($return, 1);
			}
			return $return;
		}
	}

	public function closeSale($NRSEQVENDA, $CDFILIAL, $CDCAIXA){
		$params = array(
			':NRSEQVENDA' => $NRSEQVENDA, 
			':CDFILIAL'   => $CDFILIAL,
			':CDCAIXA'    => $CDCAIXA
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CLOSE_SALE, $params);
	}

	public function cancelSale($NRSEQVENDA, $CDFILIAL, $CDCAIXA, $NRORG){
		$params = array(
			':NRSEQVENDA' => $NRSEQVENDA, 
			':CDFILIAL'   => $CDFILIAL,
			':CDCAIXA'    => $CDCAIXA,
			':NRORG'	  => $NRORG
		);
		return $this->entityManager->getConnection()->executeQuery(self::CANCEL_SALE, $params);
	}

	public function cancelMovcaixa($NRSEQVENDA, $CDFILIAL, $CDCAIXA, $NRORG){
		$params = array(
			':NRSEQVENDA' => $NRSEQVENDA, 
			':CDFILIAL'   => $CDFILIAL,
			':CDCAIXA'    => $CDCAIXA,
			':NRORG'	  => $NRORG
		);
		return $this->entityManager->getConnection()->executeQuery(self::CANCEL_MOVCAIXA, $params);
	}

	public function getEmpresa($CDFILIAL, $NRORG){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':NRORG'    => $NRORG
		);
		$response = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_EMPRESA, $params);
		return $response[0]['CDEMPRESA'];
	}

	public function getLoja($CDFILIAL, $CDCAIXA, $NRORG){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA'  => $CDCAIXA,
			':NRORG'    => $NRORG
		);
		$response = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_LOJA_ON_CAIXA, $params);
		return $response[0]['CDLOJA'];
	}

	//REDUÇÃO Z

	public function saveImpoRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $CDIMPOSTO, $VRALIQIMPRZ, $VRBCALCIMPRZ, $VRIMPOSTORZ, $NRSEQALIQIMPRZ){
		$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRORG' => $NRORG,
			':CDIMPOSTO' => $CDIMPOSTO,
			':VRALIQIMPRZ' => $VRALIQIMPRZ,
			':VRBCALCIMPRZ' => $VRBCALCIMPRZ,
			':VRIMPOSTORZ' => $VRIMPOSTORZ,
			':NRSEQALIQIMPRZ' => $NRSEQALIQIMPRZ
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_REDZ_IMPOS, $params);
	}

	public function saveTotRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRTOTNFISCRZ, $DSTOTNFISCRZ, $NRCONTOTNFIS, $VRACUTOTNFIS){
		$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRORG' => $NRORG,
			':NRTOTNFISCRZ' => $NRTOTNFISCRZ,
			':DSTOTNFISCRZ' => $DSTOTNFISCRZ,
			':NRCONTOTNFIS' => $NRCONTOTNFIS,
			':VRACUTOTNFIS' => $VRACUTOTNFIS
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_REDZ_TOT, $params);
	}

	public function savePaymentRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $CDTIPORECE, $VRFORMPGTORZ, $CDTPRECEORIG){
		$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRORG' => $NRORG,
			':CDTIPORECE' => $CDTIPORECE,
			':VRFORMPGTORZ' => $VRFORMPGTORZ,
			':CDTPRECEORIG' => $CDTPRECEORIG
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_REDZ_PAY, $params);
	}

	public function saveObsRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRSEQOBSREDZ, $DTOBSERVREDZ, $DSOBSERVREDZ){
		$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRORG' => $NRORG,
			':NRSEQOBSREDZ' => $NRSEQOBSREDZ,
			':DTOBSERVREDZ' => $DTOBSERVREDZ,
			':DSOBSERVREDZ' => $DSOBSERVREDZ
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_OBS_REDZ, $params);
	}

	public function editaImpoRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $CDIMPOSTO, $VRALIQIMPRZ, $VRBCALCIMPRZ, $VRIMPOSTORZ, $NRSEQALIQIMPRZ){
		$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRORG' => $NRORG,
			':CDIMPOSTO' => $CDIMPOSTO,
			':VRALIQIMPRZ' => $VRALIQIMPRZ,
			':VRBCALCIMPRZ' => $VRBCALCIMPRZ,
			':VRIMPOSTORZ' => $VRIMPOSTORZ,
			':NRSEQALIQIMPRZ' => $NRSEQALIQIMPRZ
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_REDZ_IMPOS, $params);
	}

	public function editaTotRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRTOTNFISCRZ, $DSTOTNFISCRZ, $NRCONTOTNFIS, $VRACUTOTNFIS){
		$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRORG' => $NRORG,
			':NRTOTNFISCRZ' => $NRTOTNFISCRZ,
			':DSTOTNFISCRZ' => $DSTOTNFISCRZ,
			':NRCONTOTNFIS' => $NRCONTOTNFIS,
			':VRACUTOTNFIS' => $VRACUTOTNFIS
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_REDZ_TOT, $params);
	}

	public function editaPaymentRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $CDTIPORECE, $VRFORMPGTORZ, $CDTPRECEORIG){
		$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRORG' => $NRORG,
			':CDTIPORECE' => $CDTIPORECE,
			':VRFORMPGTORZ' => $VRFORMPGTORZ,
			':CDTPRECEORIG' => $CDTPRECEORIG
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_REDZ_PAY, $params);
	}

	public function saveReducaoZ($DTREDUCAOZ, $NRECFREDZ, $NRREINIREDZ, $NRSERIEREDZ, $NRREDREDZ, $NRLEITREDZ, $NRGERCNFREDZ, $NRCANCFREDZ, $NRPRIMCFREDZ, $NRULTCFREDZ, $VRGTREDZ, $VRVENBRUREDZ, $VRISSREDZ, $VRTOTCANREDZ, $VRTOTDESREDZ, $VRVENLIQREDZ, $VRTOTACRREDZ, $IDORIGEMREDZ, $DSMODMARCAECF, $NRORG, $CDFILIAL, $CDCAIXA, $VRSTRIBREDZ, $VRISENCREDZ, $VRNINCIDREDZ, $QTTEMLIGREDZ, $QTTEMPCFREDZ, $QTMEMRESREDZ){
		$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':NRREINIREDZ' => $NRREINIREDZ,
			':NRSERIEREDZ' => $NRSERIEREDZ,
			':NRREDREDZ' => $NRREDREDZ,
			':NRLEITREDZ' => $NRLEITREDZ,
			':NRGERCNFREDZ' => $NRGERCNFREDZ,
			':NRCANCFREDZ' => $NRCANCFREDZ,
			':NRPRIMCFREDZ' => $NRPRIMCFREDZ,
			':NRULTCFREDZ' => $NRULTCFREDZ,
			':VRGTREDZ' => $VRGTREDZ,
			':VRVENBRUREDZ' => $VRVENBRUREDZ,
			':VRISSREDZ' => $VRISSREDZ,
			':VRTOTCANREDZ' => $VRTOTCANREDZ,
			':VRTOTDESREDZ' => $VRTOTDESREDZ,
			':VRVENLIQREDZ' => $VRVENLIQREDZ,
			':VRTOTACRREDZ' => $VRTOTACRREDZ,
			':IDORIGEMREDZ' => $IDORIGEMREDZ,
			':DSMODMARCAECF' => $DSMODMARCAECF,
			':NRORG' => $NRORG,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':VRSTRIBREDZ' => $VRSTRIBREDZ,
			':VRISENCREDZ' => $VRISENCREDZ,
			':VRNINCIDREDZ' => $VRNINCIDREDZ,
			':QTTEMLIGREDZ' => $QTTEMLIGREDZ,
			':QTTEMPCFREDZ' => $QTTEMPCFREDZ,
			':QTMEMRESREDZ' => $QTMEMRESREDZ
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_REDZ, $params);
	}

	public function editReducaoZ($DTREDUCAOZ, $NRECFREDZ, $NRREINIREDZ, $NRSERIEREDZ, $NRREDREDZ, $NRLEITREDZ, $NRGERCNFREDZ, $NRCANCFREDZ, $NRPRIMCFREDZ, $NRULTCFREDZ, $VRGTREDZ, $VRVENBRUREDZ, $VRISSREDZ, $VRTOTCANREDZ, $VRTOTDESREDZ, $VRVENLIQREDZ, $VRTOTACRREDZ, $IDORIGEMREDZ, $DSMODMARCAECF, $NRORG, $CDFILIAL, $CDCAIXA, $VRSTRIBREDZ, $VRISENCREDZ, $VRNINCIDREDZ, $QTTEMLIGREDZ, $QTTEMPCFREDZ, $QTMEMRESREDZ){
			$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':NRREINIREDZ' => $NRREINIREDZ,
			':NRSERIEREDZ' => $NRSERIEREDZ,
			':NRREDREDZ' => $NRREDREDZ,
			':NRLEITREDZ' => $NRLEITREDZ,
			':NRGERCNFREDZ' => $NRGERCNFREDZ,
			':NRCANCFREDZ' => $NRCANCFREDZ,
			':NRPRIMCFREDZ' => $NRPRIMCFREDZ,
			':NRULTCFREDZ' => $NRULTCFREDZ,
			':VRGTREDZ' => $VRGTREDZ,
			':VRVENBRUREDZ' => $VRVENBRUREDZ,
			':VRISSREDZ' => $VRISSREDZ,
			':VRTOTCANREDZ' => $VRTOTCANREDZ,
			':VRTOTDESREDZ' => $VRTOTDESREDZ,
			':VRVENLIQREDZ' => $VRVENLIQREDZ,
			':VRTOTACRREDZ' => $VRTOTACRREDZ,
			':IDORIGEMREDZ' => $IDORIGEMREDZ,
			':DSMODMARCAECF' => $DSMODMARCAECF,
			':NRORG' => $NRORG,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':VRSTRIBREDZ' => $VRSTRIBREDZ,
			':VRISENCREDZ' => $VRISENCREDZ,
			':VRNINCIDREDZ' => $VRNINCIDREDZ,
			':QTTEMLIGREDZ' => $QTTEMLIGREDZ,
			':QTTEMPCFREDZ' => $QTTEMPCFREDZ,
			':QTMEMRESREDZ' => $QTMEMRESREDZ
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_REDZ, $params);
	}

	public function getNRSEQOBS ($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ){
		$params = array(
			':CDFILIAL' =>$CDFILIAL, 
			':CDCAIXA' =>$CDCAIXA, 
			':NRECFREDZ' =>$NRECFREDZ, 
			':DTREDUCAOZ' =>$DTREDUCAOZ
		);
		$NRSEQOBSREDZ = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_NRSEQOBSREDZ, $params);
		if (strlen($NRSEQOBSREDZ[0]['NRSEQOBSREDZ']) > 1){
			if (strlen($NRSEQOBSREDZ[0]['NRSEQOBSREDZ']) > 2){
				if (strlen($NRSEQOBSREDZ[0]['NRSEQOBSREDZ']) > 3){
					return (string)($NRSEQOBSREDZ[0]['NRSEQOBSREDZ']);
				}
				return (string)'0'.($NRSEQOBSREDZ[0]['NRSEQOBSREDZ']);
			}
			return (string)'00'.($NRSEQOBSREDZ[0]['NRSEQOBSREDZ']);
		}else{
			return (string)'000'.($NRSEQOBSREDZ[0]['NRSEQOBSREDZ']);
		}
	}

	public function getNRTOTNFISCRZ ($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ){
		$params = array(
			':CDFILIAL' =>$CDFILIAL, 
			':CDCAIXA' =>$CDCAIXA, 
			':NRECFREDZ' =>$NRECFREDZ, 
			':DTREDUCAOZ' =>$DTREDUCAOZ
		);
		$NRTOTNFISCRZ = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_NRTOTNFISCRZ, $params);
		if (strlen($NRTOTNFISCRZ[0]['NRTOTNFISCRZ']) > 1){
			return(string)($NRTOTNFISCRZ[0]['NRTOTNFISCRZ']);
		}else{
			return (string)'0'.($NRTOTNFISCRZ[0]['NRTOTNFISCRZ']);
		}
	}

	public function getNRSEQALIQIMPRZ ($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ){
		$params = array(
			':CDFILIAL' =>$CDFILIAL, 
			':CDCAIXA' =>$CDCAIXA, 
			':NRECFREDZ' =>$NRECFREDZ, 
			':DTREDUCAOZ' =>$DTREDUCAOZ
		);
		$NRTOTNFISCRZ = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_NRSEQALIQIMPRZ, $params);
		if (strlen($NRTOTNFISCRZ[0]['NRSEQOBSREDZ']) > 1){
			return(string)($NRTOTNFISCRZ[0]['NRSEQOBSREDZ']);
		}else{
			return (string)'0'.($NRTOTNFISCRZ[0]['NRSEQOBSREDZ']);
		}
	}

	public function verifyTiporece ($CDFILIAL, $CDCAIXA, $DTREDUCAOZ, $NRECFREDZ, $CDTIPORECE){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':CDTIPORECE' => $CDTIPORECE
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFY_TIPORECE, $params);
	}

	public function verifyReducaoZ($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA){
		$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ, 
			':NRECFREDZ' => $NRECFREDZ, 
			':CDFILIAL' => $CDFILIAL, 
			':CDCAIXA' => $CDCAIXA
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFY_REDZ, $params);
	}

	public function deleteCascadeRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG){
		$params = array(
			':DTREDUCAOZ' => $DTREDUCAOZ,
			':NRECFREDZ' => $NRECFREDZ,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':NRORG' => $NRORG
		);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_IMP_REDZ, $params);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_TOT_REDZ, $params);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_PAY_REDZ, $params);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_OBS_REDZ, $params);
	}
	
	public function deleteItens($CDFILIAL, $NRSEQVENDA, $NRSEQUITVEND, $NRSEQITIMPOS, $CAIXA, $NRORG){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':NRSEQVENDA' => $NRSEQVENDA,
			':NRSEQUITVEND' => $NRSEQUITVEND,
			':NRSEQITIMPOS' => $NRSEQITIMPOS,
			':CDCAIXA'		=> $CAIXA,
			':NRORG' => $NRORG
		);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_ITENS, $params);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_IMP_ITENS, $params);
	}
	public function deleteItensCan($CDFILIAL, $NRSEQVENDA, $NRSEQITVENDC, $CAIXA, $NRORG){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':NRSEQVENDA' => $NRSEQVENDA,
			':NRSEQITVENDC' => $NRSEQITVENDC,
			':CDCAIXA'		=> $CAIXA,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_ITENS_CANC, $params);
	}
	public function deleteRecebimentoItem($CDFILIAL, $DTABERCAIX, $NRSEQUMOVI, $CAIXA, $NRORG){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':DTABERCAIX' => $DTABERCAIX,
			':NRSEQUMOVI' => $NRSEQUMOVI,
			':CDCAIXA'		=> $CAIXA,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_ITENS_RECEBIMENTOS, $params);
	}
	
	public function updateItensRecebimento($params){
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_ITENS_RECEBIMENTOS, $params);
	}
	
	public function checkProdutGroup($CDFILIAL, $NRORG){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->fetchAll(self::CHECK_PRODUCT_GROUP, $params);
	}
	
	
	public function findProdutGroup($CDFILIAL, $NRORG){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->fetchAll(self::FIND_PRODUCT_GROUP, $params);
	}
	
	public function checkTabelaPreco($CDFILIAL, $NRORG, $CDCLIENTE, $CDLOJA){
		$dataAtual = new \DateTime();
		$retorno = false;
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':NRORG' => $NRORG,
			':CDCLIENTE' => $CDCLIENTE,
			':CDLOJA' => $CDLOJA
		);
		$clienteFilial = $this->entityManager->getConnection()->fetchAll(self::CHECK_CLIENTE_FILIAL, $params);
		if(isset($clienteFilial[0]) && !$clienteFilial[0]['CDTABEPREC']){
			$cliente = $this->entityManager->getConnection()->fetchAll(self::CHECK_CLIENTE, $params);
			if($cliente[0]['CDTABEPREC']){ // VERIFICA SE A TABELA DE PRECO DO CLIENTE TEM VIGENCIA VALIDA
				$paramsDataCliente =  array(
					':CDFILIAL' => $cliente[0]['CDFILTABPREC'],
					':NRORG' => $NRORG,
					':CDTABEPREC' => $cliente[0]['CDTABEPREC'],
					':DATA' => $dataAtual->format('d/m/Y')
				);
				$data = $this->entityManager->getConnection()->fetchAll(self::CHECK_DATA_VIGENCIA, $paramsDataCliente);
				if(count($data) > 0){
				$retorno =  [$cliente[0]['CDTABEPREC'], $cliente[0]['CDFILTABPREC'], $data];
					
				} else {
					$retorno = false;
				}
			}
			else {
				$loja = $this->entityManager->getConnection()->fetchAll(self::CHECK_LOJA, $params);
				if($loja[0]['CDTABEPREC']){ //VERIFICA SE A LOJA TEM VIGENCIA CADASTRADA
					$paramsDataLoja =  array(
						':CDFILIAL' => $CDFILIAL,
						':NRORG' => $NRORG,
						':CDTABEPREC' => $loja[0]['CDTABEPREC'],
						':DATA' => $dataAtual->format('d/m/Y')
					);
					$data = $this->entityManager->getConnection()->fetchAll(self::CHECK_DATA_VIGENCIA, $paramsDataLoja);
					if(count($data) > 0){
					$retorno =  [$loja[0]['CDTABEPREC'], $CDFILIAL, $data];
						
					} else {
						$retorno = false;
					}
				} else {
					$paravend = $this->entityManager->getConnection()->fetchAssoc(self::CHECK_PARAVEND, $params);
						if($paravend['CDTABEPREC']){ //VERIFICA SE A FILIAL TEM VIGENCIA CADASTRADA
						$paramsDataParavend =  array(
							':CDFILIAL' => $CDFILIAL,
							':NRORG' => $NRORG,
							':CDTABEPREC' => $paravend['CDTABEPREC'],
							':DATA' => $dataAtual->format('d/m/Y')
						);
						$data = $this->entityManager->getConnection()->fetchAll(self::CHECK_DATA_VIGENCIA, $paramsDataParavend);
						if(count($data) > 0){
						$retorno =  [$paravend['CDTABEPREC'], $CDFILIAL, $data];
							
						} else {
							$retorno = false;
						}
					}
				}
			}
		} else {
			if(isset($clienteFilial[0]) && $clienteFilial[0]['CDTABEPREC']){ // VERIFICA SE A TABELA DE PRECO DO CLIENTE TEM VIGENCIA VALIDA
				$paramsDataClienteFilial =  array(
					':CDFILIAL' => $clienteFilial[0]['CDFILTABPREC'],
					':NRORG' => $NRORG,
					':CDTABEPREC' => $clienteFilial[0]['CDTABEPREC'],
					':DATA' => $dataAtual->format('d/m/Y')
				);
				$data = $this->entityManager->getConnection()->fetchAll(self::CHECK_DATA_VIGENCIA, $paramsDataClienteFilial);
				if(count($data) > 0){
					$retorno =  [$clienteFilial[0]['CDTABEPREC'], $CDFILIAL, $data];
				} else {
					$retorno = false;
				}
			}
		}
		
		return $retorno;
		
	}
	
	public function getTabPrecProd($NRORG, $CDFILTABPREC, $CDTABPREC, $CDPRODUTO, $DATAINCLUSAO){
		$params = array(
			':CDFILIAL' => $CDFILTABPREC,
			':NRORG' => $NRORG,
			':CDTABEPREC' => $CDTABPREC,
			':DTINIVGPREC' => $DATAINCLUSAO,
			':CDPRODUTO' => $CDPRODUTO
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_PRECO_PROD_TABPREC, $params);
	}
	
	public function selectConsumidor($NRORG, $CLIENTE){
		$params = array(
			':CDCLIENTE' => $CLIENTE,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_CONSUMIDOR, $params);
	}
	
	public function selectServico($NRORG, $FILIAL){
		$params = array(
			':CDFILIAL' => $FILIAL,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_SERVICO, $params);
	}
	
	public function checkSaleValues($NRSEQVENDA, $CDFILIAL, $CDCAIXA, $NRORG){
		$params = array(
			':NRSEQVENDA' => $NRSEQVENDA, 
			':CDFILIAL'   => $CDFILIAL,
			':CDCAIXA'    => $CDCAIXA,
			":NRORG"	  => $NRORG
		);
		
		$VRVENDA	= $this->entityManager->getConnection()->fetchAll(self::GET_VALOR_VENDIDO, $params);
		$VRRECEBIDO = $this->entityManager->getConnection()->fetchAll(self::GET_VALOR_RECEBIDO, $params);
		if(!$VRVENDA[0]['SOMA']){
			$RETORNO = 0;
		} else if($VRVENDA[0]['SOMA'] != $VRRECEBIDO[0]['VALOR']){
			$RETORNO = 1;
		} else if($VRVENDA[0]['SOMA'] == $VRRECEBIDO[0]['VALOR']){
			$RETORNO = 2;
		}
		return $RETORNO;
		
		
	} 
	
	public function findItensCancelados($row){
			$params = array(
			':CDFILIAL' => $row['CDFILIAL'],
			':CDNVPRODUTO' => $row['CDNVPRODUTO'],
			':NRORG' => $row['NRORG']
		);
		return $this->entityManager->getConnection()->fetchAll(self::FIND_CANCEL_ITENS, $params);
	}
	
	const FIND_CANCEL_ITENS = "
	SELECT
		' ' AS IDMARCADO, P.CDARVPROD, P.CDPRODUTO, P.NMPRODUTO, :CDFILIAL,
		P.CDPRODINTE, P.SGUNIDADE
		FROM
		PRODUTO P LEFT JOIN PRODFILI F
			ON (F.CDPRODUTO = P.CDPRODUTO) 
		WHERE
		(P.CDNVPRODUTO = :CDNVPRODUTO) AND
		
		(F.CDFILIAL = :CDFILIAL) AND
		(NVL(F.IDPRODATIV, 'A') = 'A') AND
		(NVL(P.IDPRODATIVPR,'S') = 'S')
		ORDER BY
		P.CDARVPROD";
	
	
	const CHECK_PRODUCT_GROUP = "
	SELECT
	  F.CDFILIAL, F.NMFILIAL, F.CDSEGMER, P.CDGRPRODPDV
	FROM
	  FILIAL F    
    RIGHT JOIN PARAVEND P ON
    (F.CDFILIAL = P.CDFILIAL)
    WHERE
	  (F.CDFILIAL = :CDFILIAL) AND
	  (F.NRORG = :NRORG) AND
	  (P.NRORG = F.NRORG)  	  
	ORDER BY 
	  F.CDFILIAL
	";
	
	const FIND_PRODUCT_GROUP = "
	  SELECT  DISTINCT
	  ' ' AS IDMARCADO, PS.CDPRODUTO, PR.CDARVPROD, PR.NMPRODUTO, PR.CDPRODINTE, PR.SGUNIDADE, A.CDIMPOSTO, A.VRPEALIMPFIS,
	A.IDTPIMPOSFIS, A.NMIMPOSTO, A.SGIMPOSTO
	FROM
	   PRODUTO PR     
     JOIN PARAVEND PA ON
    (PA.CDFILIAL = :CDFILIAL) AND	 
    (PA.NRORG = PR.NRORG)    
     JOIN PRSUBGRPROD PS ON
    (PS.CDPRODUTO = PR.CDPRODUTO) AND
	  ((PS.CDFILISUBGR = :CDFILIAL) OR
	  (PS.CDFILISUBGR = 'P')) AND
    (PS.NRORG = PR.NRORG) AND
	  (PS.CDGRUPPROD = PA.CDGRPRODPDV)     
    LEFT JOIN PRODFILI PF ON
    (NVL(PF.IDPRODATIV, 'A') = 'A') AND
    (PF.CDPRODUTO = PS.CDPRODUTO) AND
	  (PF.CDFILIAL  = :CDFILIAL)    
	LEFT JOIN (SELECT AL.NRORG,AL.CDFILIAL, AL.CDPRODUTO, AL.CDIMPOSTO, AL.VRPEALIMPFIS,
	AL.IDTPIMPOSFIS, IM.SGIMPOSTO, IM.NMIMPOSTO, AL.IDINCIDEPISCOF, AL.VRALIQIBPT, AL.VRALIQIBPTES,
	AL.CDCSTICMS, AL.CDCSTPISCOF, AL.CDCFOPPFIS, AL.VRALIQPIS, AL.VRALIQCOFINS, AL.VRPERCREDUCAO,
	AL.IDMODALBASECALC, AL.CDCEST FROM ALIQIMPFIS AL
	JOIN IMPOSTO IM ON
	AL.CDIMPOSTO = IM.CDIMPOSTO 
		WHERE AL.CDFILIAL = :CDFILIAL AND 
			  AL.NRORG = :NRORG AND 
			  AL.NRORG = IM.NRORG ) A 
	ON (PR.CDPRODUTO = A.CDPRODUTO)
	WHERE	  	  
	  (NVL(PR.IDPRODATIVPR,'S') = 'S') AND 
	  (PR.NRORG = :NRORG) AND	  
	  (PF.NRORG = PR.NRORG)
	ORDER BY
	  PR.CDARVPROD";
	
	const CHECK_CLIENTE_FILIAL = "
	SELECT 
	   CDTABEPREC,
	   CDCFILTABPRE AS CDFILTABPREC
	FROM 
	   CLIENFILIAL 
	WHERE 
	         CDCLIENTE = :CDCLIENTE
	AND CDFILIAL      = :CDFILIAL
	AND NRORG = :NRORG";
	
	const CHECK_CLIENTE = "
	SELECT
	   CDFILTABPREC,
	   CDTABEPREC
	FROM 
	   CLIENTE
	WHERE
	   (CDCLIENTE = :CDCLIENTE) AND
	   (NRORG = :NRORG)
	";
	
	const CHECK_LOJA = "
	SELECT
	   CDTABEPREC
	FROM
	   LOJA
	WHERE
	   (CDFILIAL = :CDFILIAL) AND
	   (CDLOJA   = :CDLOJA  ) AND
	   (NRORG = :NRORG)";
	
	const CHECK_PARAVEND = "
   SELECT
	   CDTABEPREC, IDPRECDIFCOM
	FROM
	   PARAVEND
	WHERE
	   (CDFILIAL = :CDFILIAL)  AND 
	   (NRORG = :NRORG)
	";
	
	const  CHECK_DATA_VIGENCIA = "
	  SELECT
	   DTINIVGPREC
	FROM
	   TABEVEND
	WHERE
	   (CDFILIAL   = :CDFILIAL  ) AND
	   (CDTABEPREC = :CDTABEPREC) AND
	   (:DATA   BETWEEN DTINIVGPREC AND DTFINVGPREC) AND 
	   (NRORG = :NRORG)";
	   
	 const GET_PRECO_PROD_TABPREC = "
	 SELECT
	   NVL(VRPRECITEM,0) AS VRUNITVEND, NVL(VRPRECITEMCL,0) AS PRECOCLIE,
	   NVL(VRPRESUGITEM,0) AS PRECOSUGER, IDPRECVARIA
	FROM
	   ITEMPRECO
	WHERE
	   (CDFILIAL    = :CDFILIAL   ) AND
	   (CDTABEPREC  = :CDTABEPREC ) AND
	   (DTINIVGPREC = TO_DATE(:DTINIVGPREC, 'DD/MM/YYYY HH24:MI:SS')) AND
	   (CDPRODUTO   = :CDPRODUTO  ) AND 
	   (NRORG		= :NRORG	  )
	 ";
	 
	 const GET_CONSUMIDOR = "
	 SELECT
	   CDCONSUMIDOR, NMCONSUMIDOR, CDCCUSCLIE, CDTIPOCONS,
	   IDVERSALDCON
	FROM
	   CONSUMIDOR
	WHERE
	   (CDCLIENTE     = :CDCLIENTE   ) AND
	   (NRORG = :NRORG) AND
	   (IDSITCONSUMI  = '1')
	ORDER BY
	   CDCLIENTE
	 ";
	 
	 const GET_SERVICO = "
		     SELECT
		   CDSERVFILI, NMSERVICO
		FROM
		   SERVICO
		WHERE
		   (CDFILIAL   = :CDFILIAL) AND
		   (NRORG = :NRORG) 
		ORDER BY
		   CDSERVFILI
	 ";
	 
	 const GET_VALOR_VENDIDO = "
	SELECT
	   TRUNC(SUM((TRUNC(ITE.QTPRODVEND*(ITE.VRUNITVEND+ITE.VRUNITVENDCL),2)) - (NVL(ITE.VRDESITVEND,0) - NVL(ITE.VRACRITVEND,0))),2) AS SOMA
	FROM
	   ITEMVENDA ITE, PRODUTO PRO
	WHERE
	   ITE.CDFILIAL    = :CDFILIAL     AND
	   ITE.CDCAIXA     = :CDCAIXA      AND
	   ITE.NRSEQVENDA  = :NRSEQVENDA   AND
	   ITE.NRORG	   = :NRORG 	   AND
	   ITE.NRORG       = PRO.NRORG     AND
	   ITE.CDPRODUTO   = PRO.CDPRODUTO
	 ";
	 
	 const GET_VALOR_RECEBIDO = "
	SELECT
	   SUM(NVL(VRMOVIVEND,0)) AS VALOR
	FROM
	   MOVCAIXA
	WHERE
	   (CDFILIAL     = :CDFILIAL) AND
	   (CDCAIXA      = :CDCAIXA ) AND
	   (NRSEQVENDA   = :NRSEQVENDA) AND
	   (NRORG		 = :NRORG) AND
	   (IDTIPOMOVIVE = 'E')
	 ";
	 
	const CANCEL_MOVCAIXA = "
        UPDATE MOVCAIXA
           SET IDTIPOMOVIVE = 'C' 
         WHERE CDFILIAL     = :CDFILIAL 
           AND CDCAIXA      = :CDCAIXA 
           AND NRSEQVENDA   = :NRSEQVENDA
           AND NRORG	    = :NRORG
    ";

    const CANCEL_SALE = "
        UPDATE VENDA 
           SET IDSITUVENDA = 'C'  
         WHERE CDFILIAL    = :CDFILIAL 
           AND CDCAIXA     = :CDCAIXA 
           AND NRSEQVENDA  = :NRSEQVENDA
           AND NRORG	   = :NRORG
    ";
}